﻿<%@ Page Title="Home Page" Language="C#" MasterPageFile="~/Site.Master" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="ExcelSpreadCopyPaste._Default" %>

<%@ Register assembly="FarPoint.Web.Spread, Version=8.40.20151.0, Culture=neutral, PublicKeyToken=327c3516b1b18457" namespace="FarPoint.Web.Spread" tagprefix="FarPoint" %>

<asp:Content ID="BodyContent" ContentPlaceHolderID="MainContent" runat="server">
    <script lang="javascript" type="text/javascript">
        window.onload = function () {
            var spread = document.getElementById("<%=FpSpread1.ClientID %>");

            $('[contenteditable]').on('paste', function (e) {                
                var text = (e.originalEvent || e).clipboardData.getData('text/html');

                var newDiv = document.createElement("div");
                newDiv.innerHTML = text;
                newDiv.id = "spreadTable";
                document.getElementById("contentEditor").appendChild(newDiv);

                function addToSpread() {
                    var table = document.getElementById('spreadTable').getElementsByTagName('table')[0];
                    for (var i = 0, row; row = table.rows[i]; i++) {
                        for (var j = 0, cell; cell = row.cells[j]; j++) {
                            if (spread.Cells(i, j) != null) {
                                spread.SetValue(i, j, cell.textContent);
                                if (cell.width > 0) {
                                    spread.setColWidth(j, cell.width);
                                }
                                var rules = document.styleSheets.item(4);
                                rules = rules.cssRules || rules.rules;
                                for (var k = 0; k < rules.length; k++) {
                                    if (rules.item(k).selectorText == "." + cell.className) {
                                        var currentCell = spread.Cells(i, j);
                                        currentCell.SetBackColor(rules.item(k).style.backgroundColor);
                                        currentCell.SetForeColor(rules.item(k).style.color);
                                        break;
                                    }
                                }
                                if (cell.height > 0) {
                                    var spreadRowHeader = document.getElementById('MainContent_FpSpread1_rh');
                                    if (spreadRowHeader.rows[i].style.height != null) {
                                        spreadRowHeader.rows[i].style.height = cell.height + 'px';
                                    }
                                    var spreadTable = document.getElementById('MainContent_FpSpread1_viewport');
                                    if (spreadTable.rows[i].style.height != null) {
                                        spreadTable.rows[i].style.height = cell.height + 'px';
                                    }
                                }
                            }
                        }
                    }
                    spread.SetSelectedRange(0, 0, i, j);
                }

                addToSpread();

                var removeDiv = document.getElementById('contentEditor');
                if (removeDiv) {
                    removeDiv.hidden = true;
                }
            });
        }
 
    </script>
    <div id="xyz" class="jumbotron">
        <h1>Excel-Spread Copy-Paste</h1>
        <p>You can copy cells from an Excel file and put them into the Spreadsheet below!</p>
        <div class="toggle" id="contentEditor" contenteditable style="background: #ffffff">
            <p>Paste cells here!</p>
        </div>
        <FarPoint:FpSpread ID="FpSpread1" runat="server" BorderColor="#A0A0A0" BorderStyle="Solid" BorderWidth="1px" Height="400px" Width="1000px">
            <commandbar backcolor="#F6F6F6" buttonfacecolor="Control" buttonhighlightcolor="ControlLightLight" buttonshadowcolor="ControlDark">
            </commandbar>
            <sheets>
                <FarPoint:SheetView SheetName="Sheet1">
                </FarPoint:SheetView>
            </sheets>
        </FarPoint:FpSpread>
    </div>

</asp:Content>
